Index: Tools/scripts/bump_portrevision.sh
===================================================================
RCS file: Tools/scripts/bump_portrevision.sh
diff -N Tools/scripts/bump_portrevision.sh
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Tools/scripts/bump_portrevision.sh	24 Feb 2011 14:11:47 -0000
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+for file in "$@"; do
+	has_rev=0
+
+	if grep -q PORTREVISION "$file"; then
+		has_rev=1
+	fi
+
+	tempfile="${file}.bumprev$$"
+
+	awk -v has_rev=$has_rev < "$file" > "$tempfile" '
+		BEGIN {
+			have_printed=0;
+		}
+
+		/PORTVERSION/ {
+			print $0;
+			if (has_rev == 0 && have_printed == 0) {
+				print "PORTREVISION?=	1";
+				have_printed=1;
+			}
+
+			next;
+		}
+
+		/PORTREVISION/ {
+			if (have_printed == 1) {
+				print $0;
+				next;
+			}
+
+			start = match($0, "[0-9]+");
+
+			if (start != 0) {
+				len = length;
+				stop = RLENGTH;
+
+				if (stop == len-start+1) {
+					remainder = "";
+				} else {
+					remainder = substr($0, start+stop, \
+					    len-start-stop+2);
+				}
+
+				num = int(substr($0, start, stop)) + 1;
+				printf "%s%d%s\n", substr($0, 0, start-1), \
+				    num, remainder;
+			} else {
+				print "PORTREVISION?=	1";
+			}
+
+			have_printed = 1;
+
+			next;
+		}
+
+		{
+			print $0;
+		}
+	' && cp "$tempfile" "$file"
+	rm "$tempfile"
+
+done
+
